<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.hzya.frame.mdm.mdmModuleDbFiledsRule.dao.impl.MdmModuleDbFiledsRuleDaoImpl">

    <resultMap id="get-MdmModuleDbFiledsRuleEntity-result"
               type="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        <result property="id" column="id" jdbcType="VARCHAR"/>
        <result property="mdmId" column="mdm_id" jdbcType="VARCHAR"/>
        <result property="formName" column="form_name" jdbcType="VARCHAR"/>
        <result property="dbId" column="db_id" jdbcType="VARCHAR"/>
        <result property="filedId" column="filed_id" jdbcType="VARCHAR"/>
        <result property="ruleName" column="rule_name" jdbcType="VARCHAR"/>
        <result property="ruleCode" column="rule_code" jdbcType="VARCHAR"/>
        <result property="ruleValue" column="rule_value" jdbcType="VARCHAR"/>
        <result property="ruleType" column="rule_type" jdbcType="VARCHAR"/>
        <result property="sorts" column="sorts" jdbcType="INTEGER"/>
        <result property="create_user_id" column="create_user_id" jdbcType="VARCHAR"/>
        <result property="create_time" column="create_time" jdbcType="TIMESTAMP"/>
        <result property="modify_user_id" column="modify_user_id" jdbcType="VARCHAR"/>
        <result property="modify_time" column="modify_time" jdbcType="TIMESTAMP"/>
        <result property="sts" column="sts" jdbcType="VARCHAR"/>
        <result property="org_id" column="org_id" jdbcType="VARCHAR"/>
        <result property="companyId" column="company_id" jdbcType="VARCHAR"/>
    </resultMap>
    <!-- 查询的字段-->
    <sql id="MdmModuleDbFiledsRuleEntity_Base_Column_List">
        id
       ,mdm_id 
        ,form_name 
        ,db_id 
        ,filed_id 
        ,rule_name 
        ,rule_code 
        ,rule_value 
        ,rule_type 
        ,sorts 
        ,create_user_id 
        ,create_time 
        ,modify_user_id 
        ,modify_time 
        ,sts 
        ,org_id 
        ,company_id
    </sql>
    <!-- 查询 采用==查询 -->
    <select id="entity_list_base" resultMap="get-MdmModuleDbFiledsRuleEntity-result"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        select
        <include refid="MdmModuleDbFiledsRuleEntity_Base_Column_List"/>
        from mdm_module_db_fileds_rule
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id = #{id}</if>
            <if test="mdmId != null and mdmId != ''">and mdm_id = #{mdmId}</if>
            <if test="formName != null and formName != ''">and form_name = #{formName}</if>
            <if test="dbId != null and dbId != ''">and db_id = #{dbId}</if>
            <if test="filedId != null and filedId != ''">and filed_id = #{filedId}</if>
            <if test="ruleName != null and ruleName != ''">and rule_name = #{ruleName}</if>
            <if test="ruleCode != null and ruleCode != ''">and rule_code = #{ruleCode}</if>
            <if test="ruleValue != null and ruleValue != ''">and rule_value = #{ruleValue}</if>
            <if test="ruleType != null and ruleType != ''">and rule_type = #{ruleType}</if>
            <if test="sorts != null">and sorts = #{sorts}</if>
            <if test="create_user_id != null and create_user_id != ''">and create_user_id = #{create_user_id}</if>
            <if test="create_time != null">and create_time = #{create_time}</if>
            <if test="modify_user_id != null and modify_user_id != ''">and modify_user_id = #{modify_user_id}</if>
            <if test="modify_time != null">and modify_time = #{modify_time}</if>
            <if test="sts != null and sts != ''">and sts = #{sts}</if>
            <if test="org_id != null and org_id != ''">and org_id = #{org_id}</if>
            <if test="companyId != null and companyId != ''">and company_id = #{companyId}</if>
            and sts='Y'
        </trim>
        <if test=" sort == null or sort == ''.toString() ">order by sorts asc</if>
        <if test=" sort !='' and sort!=null and order !='' and order!=null ">order by ${sort} ${order}</if>
    </select>

    <!-- 查询符合条件的数量 -->
    <select id="entity_count" resultType="Integer"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        select count(1) from mdm_module_db_fileds_rule
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id = #{id}</if>
            <if test="mdmId != null and mdmId != ''">and mdm_id = #{mdmId}</if>
            <if test="formName != null and formName != ''">and form_name = #{formName}</if>
            <if test="dbId != null and dbId != ''">and db_id = #{dbId}</if>
            <if test="filedId != null and filedId != ''">and filed_id = #{filedId}</if>
            <if test="ruleName != null and ruleName != ''">and rule_name = #{ruleName}</if>
            <if test="ruleCode != null and ruleCode != ''">and rule_code = #{ruleCode}</if>
            <if test="ruleValue != null and ruleValue != ''">and rule_value = #{ruleValue}</if>
            <if test="ruleType != null and ruleType != ''">and rule_type = #{ruleType}</if>
            <if test="sorts != null">and sorts = #{sorts}</if>
            <if test="create_user_id != null and create_user_id != ''">and create_user_id = #{create_user_id}</if>
            <if test="create_time != null">and create_time = #{create_time}</if>
            <if test="modify_user_id != null and modify_user_id != ''">and modify_user_id = #{modify_user_id}</if>
            <if test="modify_time != null">and modify_time = #{modify_time}</if>
            <if test="sts != null and sts != ''">and sts = #{sts}</if>
            <if test="org_id != null and org_id != ''">and org_id = #{org_id}</if>
            <if test="companyId != null and companyId != ''">and company_id = #{companyId}</if>
            and sts='Y'
        </trim>
        <if test=" sort == null or sort == ''.toString() ">order by sorts asc</if>
        <if test=" sort !='' and sort!=null and order !='' and order!=null ">order by ${sort} ${order}</if>
    </select>

    <!-- 分页查询列表 采用like格式 -->
    <select id="entity_list_like" resultMap="get-MdmModuleDbFiledsRuleEntity-result"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        select
        <include refid="MdmModuleDbFiledsRuleEntity_Base_Column_List"/>
        from mdm_module_db_fileds_rule
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id like concat('%',#{id},'%')</if>
            <if test="mdmId != null and mdmId != ''">and mdm_id like concat('%',#{mdmId},'%')</if>
            <if test="formName != null and formName != ''">and form_name like concat('%',#{formName},'%')</if>
            <if test="dbId != null and dbId != ''">and db_id like concat('%',#{dbId},'%')</if>
            <if test="filedId != null and filedId != ''">and filed_id like concat('%',#{filedId},'%')</if>
            <if test="ruleName != null and ruleName != ''">and rule_name like concat('%',#{ruleName},'%')</if>
            <if test="ruleCode != null and ruleCode != ''">and rule_code like concat('%',#{ruleCode},'%')</if>
            <if test="ruleValue != null and ruleValue != ''">and rule_value like concat('%',#{ruleValue},'%')</if>
            <if test="ruleType != null and ruleType != ''">and rule_type like concat('%',#{ruleType},'%')</if>
            <if test="sorts != null">and sorts like concat('%',#{sorts},'%')</if>
            <if test="create_user_id != null and create_user_id != ''">and create_user_id like
                concat('%',#{create_user_id},'%')
            </if>
            <if test="create_time != null">and create_time like concat('%',#{create_time},'%')</if>
            <if test="modify_user_id != null and modify_user_id != ''">and modify_user_id like
                concat('%',#{modify_user_id},'%')
            </if>
            <if test="modify_time != null">and modify_time like concat('%',#{modify_time},'%')</if>
            <if test="sts != null and sts != ''">and sts like concat('%',#{sts},'%')</if>
            <if test="org_id != null and org_id != ''">and org_id like concat('%',#{org_id},'%')</if>
            <if test="companyId != null and companyId != ''">and company_id like concat('%',#{companyId},'%')</if>
            and sts='Y'
        </trim>
        <if test=" sort == null or sort == ''.toString() ">order by sorts asc</if>
        <if test=" sort !='' and sort!=null and order !='' and order!=null ">order by ${sort} ${order}</if>
    </select>

    <!-- 查询列表 字段采用or格式 -->
    <select id="MdmModuleDbFiledsRuleentity_list_or" resultMap="get-MdmModuleDbFiledsRuleEntity-result"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        select
        <include refid="MdmModuleDbFiledsRuleEntity_Base_Column_List"/>
        from mdm_module_db_fileds_rule
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">or id = #{id}</if>
            <if test="mdmId != null and mdmId != ''">or mdm_id = #{mdmId}</if>
            <if test="formName != null and formName != ''">or form_name = #{formName}</if>
            <if test="dbId != null and dbId != ''">or db_id = #{dbId}</if>
            <if test="filedId != null and filedId != ''">or filed_id = #{filedId}</if>
            <if test="ruleName != null and ruleName != ''">or rule_name = #{ruleName}</if>
            <if test="ruleCode != null and ruleCode != ''">or rule_code = #{ruleCode}</if>
            <if test="ruleValue != null and ruleValue != ''">or rule_value = #{ruleValue}</if>
            <if test="ruleType != null and ruleType != ''">or rule_type = #{ruleType}</if>
            <if test="sorts != null">or sorts = #{sorts}</if>
            <if test="create_user_id != null and create_user_id != ''">or create_user_id = #{create_user_id}</if>
            <if test="create_time != null">or create_time = #{create_time}</if>
            <if test="modify_user_id != null and modify_user_id != ''">or modify_user_id = #{modify_user_id}</if>
            <if test="modify_time != null">or modify_time = #{modify_time}</if>
            <if test="sts != null and sts != ''">or sts = #{sts}</if>
            <if test="org_id != null and org_id != ''">or org_id = #{org_id}</if>
            <if test="companyId != null and companyId != ''">or company_id = #{companyId}</if>
            and sts='Y'
        </trim>
        <if test=" sort == null or sort == ''.toString()  ">order by sorts asc</if>
        <if test=" sort !='' and sort!=null and order !='' and order!=null ">order by ${sort} ${order}</if>
    </select>

    <!--新增所有列-->
    <insert id="entity_insert"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        insert into mdm_module_db_fileds_rule(
        <trim suffix="" suffixOverrides=",">
            <if test="id != null and id != ''">id ,</if>
            <if test="mdmId != null and mdmId != ''">mdm_id ,</if>
            <if test="formName != null and formName != ''">form_name ,</if>
            <if test="dbId != null and dbId != ''">db_id ,</if>
            <if test="filedId != null and filedId != ''">filed_id ,</if>
            <if test="ruleName != null and ruleName != ''">rule_name ,</if>
            <if test="ruleCode != null and ruleCode != ''">rule_code ,</if>
            <if test="ruleValue != null and ruleValue != ''">rule_value ,</if>
            <if test="ruleType != null and ruleType != ''">rule_type ,</if>
            <if test="sorts != null">sorts ,</if>
            <if test="create_user_id != null and create_user_id != ''">create_user_id ,</if>
            <if test="create_time != null">create_time ,</if>
            <if test="modify_user_id != null and modify_user_id != ''">modify_user_id ,</if>
            <if test="modify_time != null">modify_time ,</if>
            <if test="sts != null and sts != ''">sts ,</if>
            <if test="org_id != null and org_id != ''">org_id ,</if>
            <if test="companyId != null and companyId != ''">company_id ,</if>
            <if test="sts == null ">sts,</if>
        </trim>
        )values(
        <trim suffix="" suffixOverrides=",">
            <if test="id != null and id != ''">#{id} ,</if>
            <if test="mdmId != null and mdmId != ''">#{mdmId} ,</if>
            <if test="formName != null and formName != ''">#{formName} ,</if>
            <if test="dbId != null and dbId != ''">#{dbId} ,</if>
            <if test="filedId != null and filedId != ''">#{filedId} ,</if>
            <if test="ruleName != null and ruleName != ''">#{ruleName} ,</if>
            <if test="ruleCode != null and ruleCode != ''">#{ruleCode} ,</if>
            <if test="ruleValue != null and ruleValue != ''">#{ruleValue} ,</if>
            <if test="ruleType != null and ruleType != ''">#{ruleType} ,</if>
            <if test="sorts != null">#{sorts} ,</if>
            <if test="create_user_id != null and create_user_id != ''">#{create_user_id} ,</if>
            <if test="create_time != null">#{create_time} ,</if>
            <if test="modify_user_id != null and modify_user_id != ''">#{modify_user_id} ,</if>
            <if test="modify_time != null">#{modify_time} ,</if>
            <if test="sts != null and sts != ''">#{sts} ,</if>
            <if test="org_id != null and org_id != ''">#{org_id} ,</if>
            <if test="companyId != null and companyId != ''">#{companyId} ,</if>
            <if test="sts == null ">'Y',</if>
        </trim>
        )
    </insert>
    <!-- 批量新增 -->
    <insert id="entityInsertBatch">
        insert into mdm_module_db_fileds_rule(mdm_id, form_name, db_id, filed_id, rule_name, rule_code, rule_value,
        rule_type, create_user_id, create_time, modify_user_id, modify_time, sts, org_id, company_id, sts)
        values
        <foreach collection="entities" item="entity" separator=",">
            (#{entity.mdmId},#{entity.formName},#{entity.dbId},#{entity.filedId},#{entity.ruleName},#{entity.ruleCode},#{entity.ruleValue},#{entity.ruleType},#{entity.create_user_id},#{entity.create_time},#{entity.modify_user_id},#{entity.modify_time},#{entity.sts},#{entity.org_id},#{entity.companyId},
            'Y')
        </foreach>
    </insert>
    <!-- 批量新增或者修改-->
    <insert id="entityInsertOrUpdateBatch">
        insert into mdm_module_db_fileds_rule(mdm_id, form_name, db_id, filed_id, rule_name, rule_code, rule_value,
        rule_type, create_user_id, create_time, modify_user_id, modify_time, sts, org_id, company_id)
        values
        <foreach collection="entities" item="entity" separator=",">
            (#{entity.mdmId},#{entity.formName},#{entity.dbId},#{entity.filedId},#{entity.ruleName},#{entity.ruleCode},#{entity.ruleValue},#{entity.ruleType},#{entity.create_user_id},#{entity.create_time},#{entity.modify_user_id},#{entity.modify_time},#{entity.sts},#{entity.org_id},#{entity.companyId})
        </foreach>
        on duplicate key update
        mdm_id = values(mdm_id),
        form_name = values(form_name),
        db_id = values(db_id),
        filed_id = values(filed_id),
        rule_name = values(rule_name),
        rule_code = values(rule_code),
        rule_value = values(rule_value),
        rule_type = values(rule_type),
        create_user_id = values(create_user_id),
        create_time = values(create_time),
        modify_user_id = values(modify_user_id),
        modify_time = values(modify_time),
        sts = values(sts),
        org_id = values(org_id),
        company_id = values(company_id)
    </insert>
    <!--通过主键修改方法-->
    <update id="entity_update"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        update mdm_module_db_fileds_rule set
        <trim suffix="" suffixOverrides=",">
            <if test="mdmId != null and mdmId != ''">mdm_id = #{mdmId},</if>
            <if test="formName != null and formName != ''">form_name = #{formName},</if>
            <if test="dbId != null and dbId != ''">db_id = #{dbId},</if>
            <if test="filedId != null and filedId != ''">filed_id = #{filedId},</if>
            <if test="ruleName != null and ruleName != ''">rule_name = #{ruleName},</if>
            <if test="ruleCode != null and ruleCode != ''">rule_code = #{ruleCode},</if>
            <if test="ruleValue != null and ruleValue != ''">rule_value = #{ruleValue},</if>
            <if test="ruleType != null and ruleType != ''">rule_type = #{ruleType},</if>
            <if test="create_user_id != null and create_user_id != ''">create_user_id = #{create_user_id},</if>
            <if test="create_time != null">create_time = #{create_time},</if>
            <if test="modify_user_id != null and modify_user_id != ''">modify_user_id = #{modify_user_id},</if>
            <if test="modify_time != null">modify_time = #{modify_time},</if>
            <if test="sts != null and sts != ''">sts = #{sts},</if>
            <if test="org_id != null and org_id != ''">org_id = #{org_id},</if>
            <if test="companyId != null and companyId != ''">company_id = #{companyId},</if>
        </trim>
        where id = #{id}
    </update>
    <!-- 逻辑删除 -->
    <update id="entity_logicDelete"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        update mdm_module_db_fileds_rule
        set sts= 'N',
            modify_time = #{modify_time},
            modify_user_id = #{modify_user_id}
        where id = #{id}
    </update>
    <!-- 多条件逻辑删除 -->
    <update id="entity_logicDelete_Multi_Condition"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        update mdm_module_db_fileds_rule set sts= 'N' ,modify_time = #{modify_time},modify_user_id = #{modify_user_id}
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id = #{id}</if>
            <if test="mdmId != null and mdmId != ''">and mdm_id = #{mdmId}</if>
            <if test="formName != null and formName != ''">and form_name = #{formName}</if>
            <if test="dbId != null and dbId != ''">and db_id = #{dbId}</if>
            <if test="filedId != null and filedId != ''">and filed_id = #{filedId}</if>
            <if test="ruleName != null and ruleName != ''">and rule_name = #{ruleName}</if>
            <if test="ruleCode != null and ruleCode != ''">and rule_code = #{ruleCode}</if>
            <if test="ruleValue != null and ruleValue != ''">and rule_value = #{ruleValue}</if>
            <if test="ruleType != null and ruleType != ''">and rule_type = #{ruleType}</if>
            <if test="sorts != null">and sorts = #{sorts}</if>
            <if test="sts != null and sts != ''">and sts = #{sts}</if>
            <if test="companyId != null and companyId != ''">and company_id = #{companyId}</if>
            and sts='Y'
        </trim>
    </update>
    <!--通过主键删除-->
    <delete id="entity_delete">
        delete
        from mdm_module_db_fileds_rule
        where id = #{id}
    </delete>

    <!-- 查询符合条件的数量 -->
    <select id="queryUserMdm" resultType="Integer"
            parameterType="com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity">
        select count(1) from mdm_module_db_fileds_rule
        <trim prefix="where" prefixOverrides="and">
            <if test="mdmId != null and mdmId != ''">and mdm_id != #{mdmId}</if>
            <if test="ruleCode != null and ruleCode != ''">and rule_code = #{ruleCode}</if>
            <if test="ruleValue != null and ruleValue != ''">and rule_value = #{ruleValue}</if>
            and sts='Y'
        </trim>
    </select>
    <!-- 查询列表 字段采用or格式 -->
    <select id="queryServiceQuote" resultMap="get-MdmModuleDbFiledsRuleEntity-result">

        SELECT filed_id,
               db_id,
               mdm_id
        from (
                 SELECT filed_id,
                        db_id,
                        mdm_id,
                        COUNT(*) as num
                 FROM mdm_module_db_fileds_rule
                 WHERE `sts` = 'Y'
                   and (
                         (rule_code = 'type' and rule_value = 'treeselect')
                         or (rule_code = 'service' and rule_value =  #{service})
                         or (rule_code = 'upId' and rule_value = #{upId})
                     )
                 GROUP BY filed_id, db_id, mdm_id) a
        WHERE a.num = 3
    </select>

</mapper>

